#ifndef FEEDBACK_CC
#define FEEDBACK_CC

//
// feedback class
// 
// Markus Geisler <geisler@primusnetz.de>
//

#include "FeedbackBuffer.h"

// constructor
FeedbackBuffer::FeedbackBuffer()
{
	int i;

	for(i=0;i<MAXTHREADS;i++)
	{
		myFeedbackBuffer[i] = (char *) malloc(MAXBUFFERSIZE);		
	}	
	syslog(7,"feedbackbuffer has been initialized!\n");
}

// destructor
FeedbackBuffer::~FeedbackBuffer()
{
	int i;

	for(i=0;i<MAXTHREADS;i++)
	{
		free(myFeedbackBuffer[i]);		
	}	
}

// daten uebergeben
void FeedbackBuffer::insertData(char *tmpBuffer,int Thread)
{
	strncpy(myFeedbackBuffer[Thread],tmpBuffer,MAXBUFFERSIZE);
}

// daten auslesen
char *FeedbackBuffer::getData()
{
	int i;
	int j;
	int pos;
	char *tmpBuffer;

	tmpBuffer = (char *)malloc(sizeof(char)*MAXBUFFERSIZE*MAXTHREADS);
	pos = 0;

	for(i=0;i<MAXTHREADS;i++)
	{
		j=0;
		while(myFeedbackBuffer[i][j]!='\0')
		{
			// kopieren
			tmpBuffer[pos] = myFeedbackBuffer[i][j];
			j++;
			pos++;
		}
	}

	return(strdup(tmpBuffer));

	free(tmpBuffer);
}

#endif
